SuperStrict

Import BaH.libsvg


' A small example showing :
'   Load an SVG
'   Display SVG image at various scales, alpha, translations and rotations.



Local head:THead = THead.create()

Graphics 640, 400, 0
	
SetBlend ALPHABLEND
	
SetClsColor 255,255,255
	
Repeat
	
	Cls
	
	head.paint()

	Flip

Until KeyHit(key_escape)
	
End

Type THead
	
	Const width:Int = 640
	Const height:Int = 400

	Field xCenter:Int = width / 2
	Field yCenter:Int = height / 2

	Field xMouse:Int
	Field yMouse:Int

	Field cairo:TSvgCairo = TSvgCairo.Create(TCairoImageSurface.CreateForPixmap(width, height,PF_BGRA8888))

	Function Create:THead()
		Local this:THead = New THead
		
		this.loadSVG()

		Return this
	End Function


	Method loadSVG()
		cairo.ParseSVG("Wilber.svg")
	End Method

	Method Paint()
	
		
		' define a clipped drawing area
		cairo.rectangle(0, 0, width, height)
		cairo.clip()

		' clear the background (white)
		cairo.Clear(1, 1, 1, width, height)
		
		update()
		draw()
	
		
		Local image:TImage = LoadImage(TCairoImageSurface(cairo.getTarget()).pixmap())
		DrawImage image, 0, 0
		
	End Method

	Method update()
		xMouse = MouseX()
		yMouse = MouseY()
	End Method

	Method draw()
		Local count:Float = 14.0
		Local alpha:Double = 1.0 / count
		Local xStep:Float = (xMouse - xCenter) / count
		Local yStep:Float = (yMouse - yCenter) / count
		Local scaleStep:Float = 0.03
		Local angle:Double = xStep
		
		For Local i:Int = 1 To count
			cairo.Save()
		
			cairo.PaintWithAlpha(0.1)
			cairo.Translate(xCenter + xStep * i, yCenter + yStep * i)
			cairo.Scale(i * scaleStep, i * scaleStep)
			cairo.Rotate(i * angle)
	
			cairo.RenderSVG()
	
			cairo.Restore()
		Next

	End Method
End Type
